//---------------------------------------------------------------------------
//
// Name:        wxImage_DemoFrm.cpp
// Author:      Jacek
// Created:     2008-11-16 16:26:34
// Description: wxImage_DemoFrm class implementation
//
//---------------------------------------------------------------------------

#include "wxImage_DemoFrm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

#include <wx/dcbuffer.h>

//----------------------------------------------------------------------------
// wxImage_DemoFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(wxImage_DemoFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(wxImage_DemoFrm::OnClose)
	EVT_SIZE(wxImage_DemoFrm::wxImage_DemoFrmSize)
	EVT_RIGHT_DOWN(wxImage_DemoFrm::wxImage_DemoFrmRightDown)
	EVT_PAINT(wxImage_DemoFrm::wxImage_DemoFrmPaint)
	EVT_MENU(ID_MNU_BLURHORIZONTAL_1001 , wxImage_DemoFrm::Mnublurhorizontal1001Click)
	EVT_MENU(ID_MNU_ROTATEHUE_1003 , wxImage_DemoFrm::Mnurotatehue1003Click)
	EVT_MENU(ID_MNU_CONVERTTOGREYSCALE_1002 , wxImage_DemoFrm::Mnuconverttogreyscale1002Click)
	EVT_MENU(ID_MNU_SETRGB_1004 , wxImage_DemoFrm::Mnusetrgb1004Click)
	EVT_MENU(ID_MNU_GETDATA_1005 , wxImage_DemoFrm::Mnugetdata1005Click)
END_EVENT_TABLE()
////Event Table End

wxImage_DemoFrm::wxImage_DemoFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();
	SetBackgroundStyle(wxBG_STYLE_CUSTOM);
	MyImage.AddHandler(new wxJPEGHandler);
	MyImage.LoadFile("test.jpg");
}

wxImage_DemoFrm::~wxImage_DemoFrm()
{
}

void wxImage_DemoFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	SetTitle(wxT("wxImage_Demo"));
	SetIcon(wxNullIcon);
	SetSize(8,8,320,334);
	Center();
	

	WxPopupMenu1 = new wxMenu(wxT(""));WxPopupMenu1->Append(ID_MNU_BLURHORIZONTAL_1001, wxT("BlurHorizontal"), wxT(""), wxITEM_NORMAL);
	WxPopupMenu1->Append(ID_MNU_ROTATEHUE_1003, wxT("RotateHue"), wxT(""), wxITEM_NORMAL);
	WxPopupMenu1->Append(ID_MNU_CONVERTTOGREYSCALE_1002, wxT("ConvertToGreyscale"), wxT(""), wxITEM_NORMAL);
	WxPopupMenu1->Append(ID_MNU_SETRGB_1004, wxT("SetRGB"), wxT(""), wxITEM_NORMAL);
	WxPopupMenu1->Append(ID_MNU_GETDATA_1005, wxT("GetData"), wxT(""), wxITEM_NORMAL);
	////GUI Items Creation End
}

void wxImage_DemoFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}

/*
 * wxImage_DemoFrmPaint
 */
void wxImage_DemoFrm::wxImage_DemoFrmPaint(wxPaintEvent& event)
{

    wxBufferedPaintDC MyDC(this);
	wxImage Img;
	Img=MyImage.Scale(GetClientSize().GetWidth(),GetClientSize().GetHeight(),wxIMAGE_QUALITY_NORMAL); //wxIMAGE_QUALITY_HIGH  lub wxIMAGE_QUALITY_NORMAL
    wxBitmap bmp(Img);
    MyDC.Clear();
    MyDC.DrawBitmap(bmp,0,0);
}

/*
 * wxImage_DemoFrmSize
 */
void wxImage_DemoFrm::wxImage_DemoFrmSize(wxSizeEvent& event)
{
	Refresh();
}

/*
 * Mnublurhorizontal1001Click
 */
void wxImage_DemoFrm::Mnublurhorizontal1001Click(wxCommandEvent& event)
{
	MyImage=MyImage.BlurHorizontal(10);
	Refresh();
}

/*
 * wxImage_DemoFrmRightDown
 */
void wxImage_DemoFrm::wxImage_DemoFrmRightDown(wxMouseEvent& event)
{
    PopupMenu(WxPopupMenu1, event.GetPosition());
}

/*
 * Mnuconverttogreyscale1002Click
 */
void wxImage_DemoFrm::Mnuconverttogreyscale1002Click(wxCommandEvent& event)
{
	MyImage=MyImage.ConvertToGreyscale();
	Refresh();
}

/*
 * Mnurotatehue1003Click
 */
void wxImage_DemoFrm::Mnurotatehue1003Click(wxCommandEvent& event)
{
	MyImage.RotateHue(0.5);
	Refresh();
}

/*
 * Mnusetrgb1004Click
 */
void wxImage_DemoFrm::Mnusetrgb1004Click(wxCommandEvent& event)
{
	for (int i=0; i<MyImage.GetWidth(); i++)
	 for (int j=0; j<MyImage.GetHeight(); j++)
	 {
            unsigned char r=MyImage.GetRed(i,j);
            unsigned char g=MyImage.GetGreen(i,j);
            unsigned char b=MyImage.GetBlue(i,j);
            MyImage.SetRGB(i,j,g,b,r);
     }
     Refresh();
}

/*
 * Mnugetdata1005Click
 */
void wxImage_DemoFrm::Mnugetdata1005Click(wxCommandEvent& event)
{
    unsigned char* data;
    data=MyImage.GetData();
    for (int i=0; i<MyImage.GetWidth()*MyImage.GetHeight()*3; i+=3)
    {
        unsigned char p=data[i];
        data[i]=data[i+1];
        data[i+1]=data[i+2];
        data[i+2]=p;
    }
    Refresh();
}
